



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>Java 集合类详解（含类图）</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">Java 集合类详解（含类图）</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-03-21 17:57:46 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<div>
<h2>0.参考文献</h2>
<p><img referrerpolicy="no-referrer"src="https://images2015.cnblogs.com/blog/418793/201607/418793-20160711200210061-1990371097.gif" /></p>
<p><strong>此图中蓝色为抽象类、深红色表示接口(Arrays除外)、绿色表示具体容器类</strong></p>
<h2>1.java集合类图</h2>
<p>1.1</p>
<p><img referrerpolicy="no-referrer"src="https://pic002.cnblogs.com/images/2012/80896/2012053020260298.jpg" /></p>
<p>1.2</p>
<p><img referrerpolicy="no-referrer"src="https://pic002.cnblogs.com/images/2012/80896/2012053020261738.gif" /></p>
<p>　　上述类图中，<strong>实线边框</strong>的是<strong>实现类</strong>，比如ArrayList，LinkedList，HashMap等，<strong>折线边框</strong>的是<strong>抽象类</strong>，比如AbstractCollection，AbstractList，AbstractMap等，而<strong>点线边框</strong>的是<strong>接口</strong>，比如Collection，Iterator，List等。</p>
<p>　　发现一个特点，上述所有的集合类，都实现了Iterator接口，这是一个用于遍历集合中元素的接口，主要包含 hashNext(),next(),remove()三种方法。它的一个子接口LinkedIterator在它的基础上又添加了三种方法，分别是 add(),previous(),hasPrevious()。也就是说如果是先Iterator接口，那么在遍历集合中元素的时候，只能往后遍历，被 遍历后的元素不会在遍历到，通常无序集合实现的都是这个接口，比如HashSet，HashMap；而那些元素有序的集合，实现的一般都是 LinkedIterator接口，实现这个接口的集合可以双向遍历，既可以通过next()访问下一个元素，又可以通过previous()访问前一个 元素，比如ArrayList。</p>
<p>　　还有一个特点就是抽象类的使用。如果要自己实现一个集合类，去实现那些抽象的接口会非常麻烦，工作量很大。这个时候就可以使用抽象类，这些抽象 类中给我们提供了许多现成的实现，我们只需要根据自己的需求重写一些方法或者添加一些方法就可以实现自己需要的集合类，工作流昂大大降低。</p>
<p>1.3</p>
<p><img referrerpolicy="no-referrer"src="https://pic002.cnblogs.com/images/2012/80896/2012053020262753.jpg" /></p>
<h2>2.详解</h2>
<h3>2.1HashSet</h3>
<p>HashSet是Set接口的一个子类，主要的特点是：里面不能存放重复元素，而且采用散列的存储方法，所以没有顺序。这里所说的没有顺序是指：元素插入的顺序与输出的顺序不一致。</p>
<h3>代码实例：HashSetDemo</h3>
<pre class="prettyprint linenums"> </pre>
<h3>代码实例：SetTest</h3>
<h3>2.2ArrayList</h3>
<p>ArrayList是List的子类，它和HashSet想法，允许存放重复元素，因此有序。集合中元素被访问的顺序取决于集合的类型。如果对 ArrayList进行访问，迭代器将从索引0开始，每迭代一次，索引值加1。然而，如果访问HashSet中的元素，每个元素将会按照某种随机的次序出 现。虽然可以确定在迭代过程中能够遍历到集合中的所有元素，但却无法预知元素被访问的次序。</p>
<h3>代码实例：ArrayListDemo</h3>
<h3>2.3LinkedList</h3>
<p>LinkedList是一种可以在任何位置进行高效地插入和删除操作的有序序列。</p>
<h3>代码实例：LinkedListTest</h3>
<h3>2.4HashMap</h3>
<p>参考之前的一篇博客：<a href="http://www.cnblogs.com/xwdreamer/archive/2012/05/14/2499339.html" rel="external nofollow noreferrer">Hashmap实现原理</a></p>
<h3>2.5WeekHashMapDemo</h3>
<p>输出结果</p>
<p>疑问：为什么value没有被回收。</p>
<h2>3.比较</h2>
<table>
<tbody>
<tr>
<td>　</td>
<td>　</td>
<td>是否有序</td>
<td>是否允许元素重复</td>
</tr>
<tr>
<td colspan="2">Collection</td>
<td>否</td>
<td>是</td>
</tr>
<tr>
<td colspan="2">List</td>
<td>是</td>
<td>是</td>
</tr>
<tr>
<td>Set</td>
<td>AbstractSet</td>
<td rowspan="2">否</td>
<td rowspan="3">否</td>
</tr>
<tr>
<td>　</td>
<td>HashSet</td>
</tr>
<tr>
<td>　</td>
<td>TreeSet</td>
<td>是（用二叉排序树）</td>
</tr>
<tr>
<td>Map</td>
<td>AbstractMap</td>
<td rowspan="2">否</td>
<td rowspan="3">使用key-value来映射和存储数据，key必须唯一，value可以重复</td>
</tr>
<tr>
<td>　</td>
<td>HashMap</td>
</tr>
<tr>
<td>　</td>
<td>TreeMap</td>
<td>是（用二叉排序树）</td>
</tr>
</tbody>
</table>
<p>原文：http://www.cnblogs.com/xwdreamer/archive/2012/05/30/2526822.html</p>
</div>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/m8zo7r1q.html">sping注解</a>
		</li>
						<li><a href="https://www.batexi.com/a/49gpz3e9.html">个人Github-欢迎交流探讨</a>
		</li>
						<li><a href="https://www.batexi.com/a/rqln0yk8.html">如何使用查尔斯代理抓取https请求</a>
		</li>
						<li><a href="https://www.batexi.com/a/m8z4exn9.html">使用gnucash查看任意时间段内的所有者权益变动表</a>
		</li>
						<li><a href="https://www.batexi.com/a/xq43ewe8.html">git 删除远程源，新增加源</a>
		</li>
						<li><a href="https://www.batexi.com/a/2q7wgve9.html">js实现自定义右键菜单--兼容IE、Firefox、Chrome</a>
		</li>
						<li><a href="https://www.batexi.com/a/1q2lzy39.html">职责链模式&lpar;chain of responsibility Pattern&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/m8z0xw3q.html">安卓第十四天笔记-内容提供者&lpar;ContentProvider&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/qxnzjzv8.html">用Python操作Excel2007 及以上的版本读写，来自官方的Demo</a>
		</li>
						<li><a href="https://www.batexi.com/a/q1z2z309.html">如何启动 SQL Server Agent（SQL Server 配置管理器）</a>
		</li>
						<li><a href="https://www.batexi.com/a/qde43mv9.html">Meth &vert; phpstorm invalid descendent file name</a>
		</li>
						<li><a href="https://www.batexi.com/a/9j0kjwgq.html">ID3算法 决策树 C&plus;&plus;实现</a>
		</li>
						<li><a href="https://www.batexi.com/a/90vwrdj8.html">删除select中所有option选项</a>
		</li>
						<li><a href="https://www.batexi.com/a/qv21d1x9.html">POIUtils  读取 poi</a>
		</li>
						<li><a href="https://www.batexi.com/a/9j1z7lg9.html">tiny4412 --Uboot移植&lpar;6&rpar;    SD卡驱动，启动内核</a>
		</li>
						<li><a href="https://www.batexi.com/a/qdw5mlx9.html">Python3 与 C&num; 扩展之～基础衍生</a>
		</li>
						<li><a href="https://www.batexi.com/a/8kjepwr9.html">bash：command not found解决方法</a>
		</li>
						<li><a href="https://www.batexi.com/a/q4j0l7jq.html">count&lpar;&ast;&rpar; 和 count&lpar;1&rpar;和count&lpar;列名&rpar;区别</a>
		</li>
						<li><a href="https://www.batexi.com/a/8zymg519.html">LoibreOJ 2042&period; 「CQOI2016」不同的最小割 最小割树 Gomory-Hu tree</a>
		</li>
						<li><a href="https://www.batexi.com/a/q7eem7j9.html">搜索页面scroll下拉时候进行刷新，显示更多搜索值</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/e9pl107q.html">NUL 与 NULL</a>
			</li>
						<li><a href="https://www.batexi.com/a/oqv65z18.html">jquery&sol;js实现验证聚焦，失焦</a>
			</li>
						<li><a href="https://www.batexi.com/a/0qw1jpz8.html">You are note Hk</a>
			</li>
						<li><a href="https://www.batexi.com/a/m8zdonn9.html">Genymotion出现unknown generic error和This may occur if you are using a proxy错误的解决方案</a>
			</li>
						<li><a href="https://www.batexi.com/a/m8zdy339.html">window下查看TCP端口连接情况</a>
			</li>
						<li><a href="https://www.batexi.com/a/oqv623z8.html">linux下清除Squid缓存的方法记录</a>
			</li>
						<li><a href="https://www.batexi.com/a/0qw1vxr8.html">Linux下CGroup使用说明梳理</a>
			</li>
						<li><a href="https://www.batexi.com/a/g8en46z8.html">纯CSS3画出小黄人并实现动画效果</a>
			</li>
						<li><a href="https://www.batexi.com/a/e9jwm608.html">VS代码片段&lpar;snippet&rpar;创作工具&mdash;&mdash;Snippet Editor（转）</a>
			</li>
						<li><a href="https://www.batexi.com/a/5qxp2g09.html">MVC3 使用 FusionCharts 做报表</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
